import javax.swing.*;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.*;
import processing.serial.*;

Serial myPort;
int stop_flag = 0;
int start_flag = 0;
String selected_port;

public class JSerialSelector extends JFrame implements ActionListener {
  JComboBox combo_port;
  JComboBox combo_baud_rate;
  JComboBox combo_parity;
  JComboBox combo_data_bits;
  JComboBox combo_stop_bits;
  JButton button_connect;
  JButton button_stop;
  JLabel label;
  JTextArea textarea;
  ButtonGroup group;
  JRadioButton radio1;
  JRadioButton radio2;
  JRadioButton radio3;
  JRadioButton radio4;
  JRadioButton radio5;
  JRadioButton radio6;
  String[] portName;

  int port_index;
  int baud_rate_index;
  int parity_index;
  int data_bits_index;
  int stop_bits_index;

  String[] ports;
  int[] baud_rate = {9600, 14400, 19200, 38400, 57600};
  char[] parity = {'N', 'E', 'O', 'M', 'S'};
  int[] data_bits = {8, 7, 6, 5};
  int[] stop_bits = {1, 2};

  public JSerialSelector() {

    String default_baud_rate = "19200";
    String default_parity = "N";
    String default_data_bits = "8";
    String default_stop_bits = "1";

    portName = new String[Serial.list().length];
    for (int i = 0; i< Serial.list().length; i++) {
      portName[i] =  Serial.list()[i];
      println("port["+i+"]=:", portName[i]);
    }

    String[] portNames = {};
    ;
    portNames = (String[])append(portNames, "");
    portNames = concat(portNames, Serial.list());

    ports = portNames;

    String[] dl_ports = ports;
    String[] dl_baud_rate = {"9600", "14400", "19200", "38400", "57600"};
    String[] dl_parity = {"N", "E", "O", "M", "S"};
    String[] dl_data_bits = {"8", "7", "6", "5"};
    String[] dl_stop_bits = {"1", "2"};

    for (int i=0; i<baud_rate.length; i++) {
      if (dl_baud_rate[i]==default_baud_rate) {
        baud_rate_index = i;
        break;
      }
    }
    for (int i=0; i<parity.length; i++) {
      if (dl_parity[i]==default_parity) {
        parity_index = i;
        break;
      }
    }
    for (int i=0; i<data_bits.length; i++) {
      if (dl_data_bits[i]==default_data_bits) {
        data_bits_index = i;
        break;
      }
    }
    for (int i=0; i<stop_bits.length; i++) {
      if (dl_stop_bits[i]==default_stop_bits) {
        stop_bits_index = i;
        break;
      }
    }

    button_stop = new JButton("Exit");
    button_connect = new JButton("Connect");

    combo_port = new JComboBox(dl_ports);
    combo_port.setPreferredSize(new Dimension(200, 30));

    combo_baud_rate = new JComboBox(dl_baud_rate);
    combo_baud_rate.setPreferredSize(new Dimension(120, 30));

    combo_parity = new JComboBox(dl_parity);
    combo_parity.setPreferredSize(new Dimension(60, 30));

    combo_data_bits = new JComboBox(dl_data_bits);
    combo_data_bits.setPreferredSize(new Dimension(60, 30));

    combo_stop_bits = new JComboBox(dl_stop_bits);
    combo_stop_bits.setPreferredSize(new Dimension(60, 30));

    textarea = new JTextArea();
    textarea.setLineWrap(true);

    JScrollPane scrollpane = new JScrollPane(textarea);
    scrollpane.setPreferredSize(new Dimension(480, 300));

    radio1 = new JRadioButton("black");
    radio2 = new JRadioButton("green");
    radio3 = new JRadioButton("purple");
    radio4 = new JRadioButton("blue");
    radio5 = new JRadioButton("orange");
    radio6 = new JRadioButton("red");

    group = new ButtonGroup();
    group.add(radio1);
    group.add(radio2);
    group.add(radio3);
    group.add(radio4);
    group.add(radio5);
    group.add(radio6);


    combo_port.addActionListener(this);
    combo_baud_rate.addActionListener(this);
    combo_parity.addActionListener(this);
    combo_data_bits.addActionListener(this);
    combo_stop_bits.addActionListener(this);

    button_connect.addActionListener(this);
    button_stop.addActionListener(this);
    radio1.addActionListener(this);
    radio2.addActionListener(this);
    radio3.addActionListener(this);
    radio4.addActionListener(this);
    radio5.addActionListener(this);
    radio6.addActionListener(this);

    JPanel p = new JPanel();
    p.add(radio1);
    p.add(radio2);
    p.add(radio3);
    p.add(radio4);
    p.add(radio5);
    p.add(radio6);
    p.add(new JLabel("Com Port:"));
    p.add(combo_port);
    p.add(new JLabel("baud rate:"));
    p.add(combo_baud_rate);
    p.add(new JLabel("parity:"));
    p.add(combo_parity);
    p.add(new JLabel("data bits:"));
    p.add(combo_data_bits);
    p.add(new JLabel("stop bits:"));
    p.add(combo_stop_bits);
    p.add(button_connect);

    p.add(scrollpane);
    p.add(button_stop);

    label = new JLabel();
    JPanel labelPanel = new JPanel();
    labelPanel.add(label);

    getContentPane().add(p, BorderLayout.CENTER);
    getContentPane().add(labelPanel, BorderLayout.PAGE_END);
  }

  public String getPort(int i) {
    return ports[i];
  }

  public int getBaudRate(int i) {
    return baud_rate[i];
  }

  public char getParity(int i) {
    return parity[i];
  }

  public int getDataBits(int i) {
    return data_bits[i];
  }
  public int getStopBits(int i) {
    return stop_bits[i];
  }

  public Serial getSerial() {
    return myPort;
  }

  public int getStart_Flag() {
    return start_flag;
  }

  public int getStop_Flag() {
    return stop_flag;
  }

  public int getChoice() {
    return choice;
  }
  public int getColor_code() {
    return color_code;
  }


  public void actionPerformed(ActionEvent e) {
    if (e.getSource()==button_stop) {
      println("Stop Button Pushed!");
      stop_flag = 1;
      exit();
    } else {
      if (e.getSource()== button_connect) {
        SelectedPort = selector.getPort(port_index);
        SelectedBaudRate = selector.getBaudRate(baud_rate_index);
        SelectedParity = selector.getParity(parity_index);
        SelectedDataBits = selector.getDataBits(data_bits_index);
        SelectedStopBits = selector.getStopBits(stop_bits_index);
        start_flag = 1;
        choice = 0; 
        serial_connect();
      }  

      if (e.getSource() == radio1)
      {
        if (radio1.isSelected()) {
          color_code = 0;
        }
      }    
      if (e.getSource() == radio2)
      {
        if (radio2.isSelected()) {
          color_code = 1;
        }
      }  
      if (e.getSource() == radio3)
      {
        if (radio3.isSelected()) {
          color_code = 2;
        }
      }  
      if (e.getSource() == radio4)
      {
        if (radio4.isSelected()) {
          color_code = 3;
        }
      }  
      if (e.getSource() == radio5)
      {
        if (radio5.isSelected()) {
          color_code = 4;
        }
      }  
      if (e.getSource() == radio6)
      {
        if (radio6.isSelected()) {
          color_code = 5;
        }
      }  

      if (e.getSource()== combo_port) {
        selected_port = (String)combo_port.getSelectedItem();
        port_index = (int)combo_port.getSelectedIndex();
        SelectedPort = selector.getPort(port_index);
      }
      if (e.getSource()== combo_baud_rate) {
        SelectedBaudRate = selector.getBaudRate(baud_rate_index);
      }
      if (e.getSource()== combo_parity) {
        SelectedParity = selector.getParity(parity_index);
      }
      if (e.getSource()== combo_data_bits) {
        SelectedDataBits = selector.getDataBits(data_bits_index);
      }
      if (e.getSource()== combo_stop_bits) {
        SelectedStopBits = selector.getStopBits(stop_bits_index);
      }
    }
  }
}

void serial_connect() {
  myPort = new Serial(this, SelectedPort, SelectedBaudRate);
  println("Selected");
  println("SelectedPort=", SelectedPort);
  println("SelectedBaudRate=", SelectedBaudRate);
  //port.clear();
}